;;;Cdigo fuente del libro "Experto AutoCAD con Visual LISP"
;;; (c) 2012 Ediciones ARTUAL, S.L. Barcelona, Espaa.
;;; (c) 2012 Reinaldo Togores. Todos los derechos reservados
;;; Se permite su uso mencionando la obra y su autor.

;;;Captulo 25.	Visual LISP como cliente ActiveX.

(defun sustituye (nuevo viejo cadena)
  (while (vl-string-search viejo cadena)
    (setq cadena (vl-string-subst nuevo viejo cadena))
  ) ;_ fin de while
) ;_ fin de defun
;;;Listado 5.12. Sustitucin de caracteres en una cadena.

(defun ax-extrae-atrib
                       (bloque constante / atributos lista)
  (setq
    atributos (vlax-variant-value
                (if constante
                  (vla-getconstantattributes
                    bloque
                  ) ;_ fin de vla-getconstantattributes
                  (vla-getattributes bloque)
                ) ;_ fin de if
              ) ;_ fin de vlax-variant-value
  ) ;_ fin de setq
  (if
    (>= (vlax-safearray-get-u-bound atributos 1) 0)
     (foreach atrib
                    (vlax-safearray->list atributos)
       (setq lista
              (cons
                (cons
                  (vlax-get-property
                    atrib
                    "TagString"
                  ) ;_ fin de vlax-get-property
                  (if
                    (= (vla-get-MTextAttribute
                         atrib
                       ) ;_ fin de vla-get-MTextAttribute
                       :vlax-true
                    ) ;_ fin de =
                     (sustituye
                       ""
                       "\\P"
                       (vlax-get-property
                         atrib
                         "TextString"
                       ) ;_ fin de vlax-get-property
                     ) ;_ fin de sustituye
                     (vlax-get-property
                       atrib
                       "TextString"
                     ) ;_ fin de vlax-get-property
                  ) ;_ fin de if
                ) ;_ fin de cons
                lista
              ) ;_ fin de cons
       ) ;_ fin de setq
     ) ;_ fin de foreach
  ) ;_ fin de if
  lista
) ;_ fin de defun
;;;Listado 23.2. Funcin estndar para extraer valores de atributos.

(defun ax-lee-atributos
       (noment / bloque resultado lista)
  (setq bloque (vlax-ename->vla-object noment))
  (setq resultado (vl-catch-all-apply
                    'vla-get-HasAttributes
                    (list bloque)
                  ) ;_ fin de vl-catch-all-apply
  ) ;_ fin de setq
  (if (eq resultado :vlax-true)
    (append (reverse (ax-extrae-atrib bloque t))
            (reverse (ax-extrae-atrib bloque nil))
    ) ;_ fin de append
  ) ;_ fin de if
) ;_ fin de defun
;;;Listado 23.3. Procesamiento de un bloque para extraer una lista con sus atributos.


