;;;Cdigo fuente del libro "Experto AutoCAD con Visual LISP"
;;; (c) 2012 Ediciones ARTUAL, S.L. Barcelona, Espaa.
;;; (c) 2012 Reinaldo Togores. Todos los derechos reservados
;;; Se permite su uso mencionando la obra y su autor.

;;;Captulo 25.	Visual LISP como cliente ActiveX.

(defun conecta-excel ()
  (setq apl-excel        (vlax-get-or-create-object
                           "excel.application"
                         ) ;_ fin de vlax-get-or-create-object
        coleccion-libros (vlax-get-property
                           apl-excel
                           "workbooks"
                         ) ;_ fin de vlax-get-property
        nuevo-libro      (vlax-invoke-method
                           coleccion-libros
                           "add"
                         ) ;_ fin de vlax-invoke-method
        coleccion-hojas  (vlax-get-property
                           nuevo-libro
                           "sheets"
                         ) ;_ fin de vlax-get-property
        hoja-1           (vlax-get-property
                           coleccion-hojas
                           "item"
                           1
                         ) ;_ fin de vlax-get-property
        celdas-excel     (vlax-get-property hoja-1 "cells")
  ) ;_ fin de setq
  (vla-put-visible apl-excel :vlax-true)
) ;_ fin de defun
;;;Listado 25.1. Funcin CONECTA-EXCEL.

(defun desconecta-excel ()
  (vlax-release-object apl-excel)
  (gc)
) ;_ fin de defun
;;;Listado 25.2. Funcin DESCONECTA-EXCEL.

(defun apl-err (msg) (desconecta-excel) (prompt msg))
;;;Listado 25.3. Funcin APL-ERR.

(defun lista->excel (nombre lista / *error* celdas-excel hoja-1
                     coleccion-hojas nuevo-libro coleccion-libros
                     apl-excel
                    )
  (setq *error* apl-err)
  (vl-load-com)
  (conecta-excel)
  (vlax-put-property hoja-1 "Name" nombre)
  (procesa-tabla lista)
  (desconecta-excel)
) ;_ fin de defun
;;;Listado 25.4. Funcin LISTA->EXCEL.

(defun procesa-tabla (lista / numfila numcol)
  (setq numfila 1
        numcol 0
  ) ;_ fin de setq
  (foreach campo (car lista)
    (dato->celda
      numfila
      (setq numcol (1+ numcol))
      (car campo)
    ) ;_ fin de dato->celda
  ) ;_ fin de foreach
  (while (setq fila (car lista))
    (setq numfila (1+ numfila)
          lista   (cdr lista)
    ) ;_ fin de setq
    (procesa-fila fila numfila)
  ) ;_ fin de while
) ;_ fin de defun
;;;Listado 25.5. Funcin PROCESA-TABLA.

(defun procesa-fila (fila numfila / numcol)
  (setq numcol 0)
  (foreach campo fila
    (dato->celda
      numfila
      (setq numcol (1+ numcol))
      (cdr campo)
    ) ;_ fin de dato->celda
  ) ;_ fin de foreach
) ;_ fin de defun
;;;Listado 25.6. Funcin procesa-fila.

(defun dato->celda (fila col valor)
  (vlax-put-property
    celdas-excel
    "Item"
    fila
    col
    (vl-princ-to-string valor)
  ) ;_ fin de vlax-put-property
) ;_ fin de defun
;;;Listado 25.7. Funcin Auxiliar DATO->CELDA.
