;;;Cdigo fuente del libro "Experto AutoCAD con Visual LISP"
;;; (c) Ediciones ARTUAL, S.L. Barcelona, Espaa.
;;; (c) 2012 Reinaldo Togores. Todos los derechos reservados
;;; Se permite su uso mencionando la obra y su autor.

;;;Captulo 11.	Seleccionar Entidades.

(defun iguales (lista-ent / tmp)
  (ssget "X"
         (list (assoc 0 lista-ent)
               (assoc 8 lista-ent)
               (if (assoc 67 lista-ent)
                 (assoc 67 lista-ent)
                 '(67 . 0)
               ) ;_ fin de if
               (if (assoc 62 lista-ent)
                 (assoc 62 lista-ent)
                 '(62 . 256)
               ) ;_ fin de if
               (if (assoc 6 lista-ent)
                 (assoc 6 lista-ent)
                 '(6 . "BYLAYER")
               ) ;_ fin de if
         ) ;_ fin de list
  ) ;_ fin de ssget
) ;_ fin de defun
;;;Listado 11.1. Seleccin de objetos de propiedades iguales.

(defun c:borra-iguales ()
  (vl-cmdf
    "._erase"
    (iguales
      (entget
        (car (entsel
               "\nDesigne objeto para borrar iguales: "
             ) ;_ fin de entsel
        ) ;_ fin de car
      ) ;_ fin de entget
    ) ;_ fin de iguales
    ""
  ) ;_ fin de vl-cmdf
  (princ)
) ;_ fin de defun
;;;Listado 11.2. Comando para borrar todos los objetos similares.

(defun sel-area (objeto clave eii esd)
  (ssget "X"
         (list (cons 0 objeto)
               (cons 410 (getvar "ctab"))
               '(-4 . ">,>,*")
               (cons clave eii)
               '(-4 . "<,<,*")
               (cons clave esd)
         ) ;_ fin de list
  ) ;_ fin de ssget
) ;_ fin de defun
;;;Listado 11.3. Seleccin por rea rectangular.

(defun sel-area-multiclave
                           (objeto capa lista-claves eii esd)
  (ssget
    "X"
    (append
      (list (cons 0 objeto)
            (cons 8 capa)
            (cons 410 (getvar "ctab"))
      ) ;_ fin de list
      (append
        '((-4 . "<OR"))
        (apply
          'append
          (mapcar '(lambda (x)
                     (list '(-4 . "<AND")
                           '(-4 . ">,>,*")
                           (cons x eii)
                           '(-4 . "<,<,*")
                           (cons x esd)
                           '(-4 . "AND>")
                     ) ;_ fin de list
                   ) ;_ fin de lambda
                  lista-claves
          ) ;_ fin de mapcar
        ) ;_ fin de apply
        '((-4 . "OR>"))
      ) ;_ fin de append
    ) ;_ fin de append
  ) ;_ fin de ssget
) ;_ fin de defun
;;;Listado 11.4. Seleccin por rea utilizando varias claves.

(defun sel-fuera (objeto clave eii esd)
  (ssget "X"
         (list (cons 0 objeto)
               (cons 410 (getvar "ctab"))
               '(-4 . "<OR")
               '(-4 . "<XOR") ;_ condicin para coordenada X
               '(-4 . ">,*,*")
               (cons clave eii)
               '(-4 . "<,*,*")
               (cons clave esd)
               '(-4 . "XOR>")
               '(-4 . "<XOR") ;_ condicin para coordenada Y
               '(-4 . "*,>,*")
               (cons clave eii)
               '(-4 . "*,<,*")
               (cons clave esd)
               '(-4 . "XOR>")
               '(-4 . "OR>")
         ) ;_ fin de list
  ) ;_ fin de ssget
) ;_ fin de defun
;;;Listado 11.5. Seleccin de todos los objetos fuera de un rea rectangular.

(defun C:DEMO-SEL-AREA (/ *error* ant-col dentro sel eii esd)
  (defun *error* ()
    (vla-EndUndoMark *aesl:dibujo*)
    (setvar "CECOLOR" ant-col)
    (cmd-salir)
  ) ;_ fin de defun
  (vla-StartUndoMark *aesl:dibujo*)
  (cmd-entrar)
  (setq ant-col (getvar "CECOLOR"))
  (initget 1 "Dentro Fuera")
  (setq opc (getkword "\nSeleccionar [Dentro/Fuera]: "))
  (if (= opc "Dentro")
    (setq dentro t)
  ) ;_ fin de if
  (setvar "cecolor" "5")
  (vl-cmdf "._zoom" "_w" '(0.0 0.0) '(297.0 210.0))
  (vl-cmdf "._circle" '(10.0 10.0) 2.5)
  (vl-cmdf "._array" (entlast) "" "_r" 20 25 10.0 10.0)
  (prompt "\nDesigne rea para la seleccin: ")
  (setq eii (getpoint "\nEsquina inferior izquierda: ")
        esd (getcorner eii "\nEsquina superior derecha: ")
  ) ;_ fin de setq
  (if (apply 'and (mapcar '<= eii esd))
    (progn
      (getstring
        "\nPresione una tecla para un slo crculo visible: "
      ) ;_ fin de getstring
      (vl-cmdf "._zoom" "_w" '(5.0 5.0) '(15.0 15.0))
      (setq sel (if dentro
                  (sel-area "CIRCLE" 10 eii esd)
                  (sel-fuera "CIRCLE" 10 eii esd)
                ) ;_ fin de if
      ) ;_ fin de setq
      (vl-cmdf "._change" sel "" "_p" "_c" 1 "")
      (getstring
        "\nPresione una tecla para regresar a la vista anterior: "
      ) ;_ fin de getstring
      (vl-cmdf "._zoom" "_p")
      (alert
        (strcat
          (itoa (sslength sel))
          " crculos seleccionados\ncambiados a ROJO"
        ) ;_ fin de strcat
      ) ;_ fin de alert
      (cmd-salir)
      (setvar "CECOLOR" ant-col)
      (vla-EndUndoMark *aesl:dibujo*)
    ) ;_ fin de progn
    (progn (vl-cmdf "._undo" "_back")
           (prompt "\nError en la ejecucin!")
    ) ;_ fin de progn
  ) ;_ fin de if
  (princ)
) ;_ fin de defun
;;;Listado 11.6. Demostracin de funciones de seleccin por rea.

(defun ss+ (/ conj-sel tmp)
  (setvar "grips" 1) ; para 2011 (setvar "grips" 2)
  (setq conj-sel (ssadd))
  (while (setq
           tmp (entsel "\nSeleccione objeto para aadir: ")
         ) ;_ fin de setq
    (ssadd (car tmp) conj-sel)
    (sssetfirst nil conj-sel)
  ) ;_ fin de while
  conj-sel
) ;_ fin de defun
;;;Listado 11.7. Demostracin del uso de SSADD.

(defun ss++ (/ conj-sel tmp aadir)
  (setvar "grips" 1)
  (setq conj-sel (ssadd)
        aadir   t
  ) ;_ fin de setq
  (initget "Quitar")
  (while (setq tmp
                (getpoint (strcat "\nSeleccione objeto para "
                                  (if aadir
                                    "aadir[Quitar]: "
                                    "quitar[Aadir]: "
                                  ) ;_ fin de if
                          ) ;_ fin de strcat
                ) ;_ fin de getpoint
         ) ;_ fin de setq
    (cond
      ((listp tmp)
       (if (setq tmp (ssget tmp))
         (progn (apply (if aadir
                         'ssadd
                         'ssdel
                       ) ;_ fin de if
                       (list (ssname tmp 0) conj-sel)
                ) ;_ fin de apply
                (sssetfirst conj-sel)
         ) ;_ fin de progn
       ) ;_ fin de if
      )
      ((= tmp "Quitar") (setq aadir nil))
      (t (setq aadir t))
    ) ;_ fin de cond
    (initget (if aadir
               "Quitar"
               "Aadir"
             ) ;_ fin de if
    ) ;_ fin de initget
  ) ;_ fin de while
  conj-sel
) ;_ fin de defun
;;;Listado 11.8. Construccin de un conjunto de seleccin aadiendo y quitando entidades.

(defun ss->ax-ss
                 (conj-sel nombre-sel col-sel / sel)
  (if (vl-catch-all-error-p
        (setq sel (vl-catch-all-apply
                    'vla-add
                    (list col-sel nombre-sel)
                  ) ;_ fin de vl-catch-all-apply
        ) ;_ fin de setq
      ) ;_ fin de vl-catch-all-error-p
    (vla-clear
      (setq sel (vla-item col-sel nombre-sel))
    ) ;_ fin de vla-clear
  ) ;_ fin de if
  (vla-additems sel (ss->matriz conj-sel))
  (vla-item col-sel nombre-sel)
) ;_ fin de defun
;;;Listado 11.9. Transformacin de un PICKSET en SelectionSet.

(defun ss->matriz (conj-sel / indice matriz)
  (setq indice 0
        matriz (vlax-make-safearray
                 vlax-vbObject
                 (cons 0 (1- (sslength conj-sel)))
               ) ;_ fin de vlax-make-safearray
  ) ;_ fin de setq
  (repeat (sslength conj-sel)
    (vlax-safearray-put-element
      matriz
      indice
      (vlax-ename->vla-object (ssname conj-sel indice))
    ) ;_ fin de vlax-safearray-put-element
    (setq indice (1+ indice))
  ) ;_ fin de repeat
  (vlax-make-variant matriz)
) ;_ fin de defun
;;;Listado 11.10. Pasar objetos de un PICKSET a una matriz.

(defun VxSsetFilter (Flt)
  (mapcar '(lambda (Typ Dat) (VxListToArray Typ Dat))
          (list vlax-vbInteger vlax-vbVariant)
          (list (mapcar 'car Flt) (mapcar 'cdr Flt))
  ) ;_ fin de mapcar
) ;_ fin de defun
;;;Listado 11.11. Creacin automtica de filtros de seleccin.
;;; 2002 MENZI ENGINEERING GmbH, Switzerland. <http://www.menziengineering.ch/>

(defun VxListToArray (Typ Lst)
  (vlax-make-variant
    (vlax-safearray-fill
      (vlax-make-safearray
        Typ
        (cons 0 (1- (length Lst)))
      ) ;_ fin de vlax-make-safearray
      Lst
    ) ;_ fin de vlax-safearray-fill
  ) ;_ fin de vlax-make-variant
) ;_ fin de defun
;;;Listado 11.12. Funcin VxListToArray .
;;; 2002 MENZI ENGINEERING GmbH, Switzerland. <http://www.menziengineering.ch/>


(defun ax-sel-borde (conj-sel lista-puntos lista-filtros)
  (apply 'vla-SelectByPolygon
         (append (list conj-sel acSelectionSetFence lista-puntos)
                 (vxssetfilter lista-filtros)
         ) ;_ fin de append
  ) ;_ fin de apply
) ;_ fin de defun
;;;Listado 11.13. Seleccin por borde con ActiveX.

(defun ax-lista->variant (lista)
  (vlax-make-variant
    (vlax-safearray-fill
      (vlax-make-safearray
        vlax-vbObject
        (cons 0 (1- (length lista)))
      ) ;_ fin de vlax-make-safearray
      lista
    ) ;_ fin de vlax-safearray-fill
  ) ;_ fin de vlax-make-variant
) ;_ fin de defun
;;;Listado 11.14. Conversin de la lista en un array.

(defun ax-no-grupo (lista-obj obj-grupo / tmp)
  (vlax-for obj obj-grupo
    (setq tmp (cons (vla-get-handle obj) tmp))
  ) ;_ fin de vlax-for
  (foreach obj lista-obj
    (if (member (vla-get-handle obj) tmp)
      (setq lista-obj (vl-remove obj lista-obj))
    ) ;_ fin de if
  ) ;_ fin de foreach
  lista-obj
) ;_ fin de defun
;;;Listado 11.15. Funcin que detecta y elimina objetos que pertenecen a un Grupo.

(defun ax-suma-grupo
                     (nombre lista-obj / col-grupos grupo)
  (setq col-grupos (vla-get-Groups *aesl:dibujo*)
        grupo      (vl-catch-all-apply
                     'vla-Item
                     (list col-grupos nombre)
                   ) ;_ fin de vl-catch-all-apply
  ) ;_ fin de setq
  (cond
    ((vl-catch-all-error-p grupo)
     (setq grupo (vla-Add col-grupos nombre))
     (vla-AppendItems
       grupo
       (ax-lista->variant lista-obj)
     ) ;_ fin de vla-AppendItems
     grupo
    )
    (t
     (if (setq objetos (ax-no-grupo lista-obj grupo))
       (vla-AppendItems
         grupo
         (ax-lista->variant objetos)
       ) ;_ fin de vla-AppendItems
     ) ;_ fin de if
     grupo
    )
  ) ;_ fin de cond
) ;_ fin de defun
;;;Listado 11.16. Funcin para aadir entidades a un grupo.

(defun ax-si-grupo (lista-obj obj-grupo / tmp)
  (vlax-for obj obj-grupo
    (setq tmp (cons (vla-get-handle obj) tmp))
  ) ;_ fin de vlax-for
  (foreach obj lista-obj
    (if (not (member (vla-get-handle obj) tmp))
      (setq lista-obj (vl-remove obj lista-obj))
    ) ;_ fin de if
  ) ;_ fin de foreach
  lista-obj
) ;_ fin de defun
;;;Listado 11.17. Funcin que elimina de la lista objetos que no sean parte del grupo.


(defun ax-resta-grupo
                      (nombre lista-obj / col-grupos grupo)
  (setq col-grupos (vla-get-Groups *aesl:dibujo*)
        grupo      (vl-catch-all-apply
                     'vla-Item
                     (list col-grupos nombre)
                   ) ;_ fin de vl-catch-all-apply
  ) ;_ fin de setq
  (cond
    ((vl-catch-all-error-p grupo) nil)
    (t
     (if (setq objetos (ax-si-grupo lista-obj grupo))
       (vla-RemoveItems
         grupo
         (ax-lista->variant objetos)
       ) ;_ fin de vla-RemoveItems
     ) ;_ fin de if
     (if (= (vla-get-Count grupo) 0)
       (vla-Delete grupo)
       grupo
     ) ;_ fin de if
    )
  ) ;_ fin de cond
) ;_ fin de defun
;;;Listado 11.18. Funcin que quita entidades de un grupo.

;|Visual LISP Format Options
(67 2 40 2 T "fin de " 55 9 0 0 1 nil T nil T)
;*** NO aadir texto a continuacin del comentario! ***|;
