;;;Captulo 2.	Para comenzar: un Proyecto paso a paso

;;;Funcin numera-dicc:
;;;Crea el diccionario si no existiera,
;;;con valores por defecto.
(defun numera-dicc ()
  (vl-load-com)
  (if (not (dictsearch (namedobjdict) "VARS-NUMERA"))
    (progn (vlax-ldata-put "VARS-NUMERA" "CIFRA" 0)
           (vlax-ldata-put "VARS-NUMERA" "INCREM" 10)
           (vlax-ldata-put
             "VARS-NUMERA"
             "ALTURA"
             (getvar "TEXTSIZE")
           ) ;_ fin de vlax-ldata-put
    ) ;_ fin de progn
  ) ;_ fin de if
) ;_ fin de defun
;;;Figura 2.5. Funcin numera-dicc.

;;;Incrementa el valor de CIFRA
;;;uardado en "VARS-"
(defun num-prox ()
  (vlax-ldata-put
    "VARS-"
    "CIFRA"
    (+ (vlax-ldata-get "VARS-" "CIFRA")
       (vlax-ldata-get "VARS-" "INCREM")
    ) ;_ fin de +
  ) ;_ fin de vlax-ldata-put
) ;_ fin de defun
;;;Figura 2.6. Funcin num-prox.

;;;Funcin genrica para dibujar textos
(defun dib-texto (pt-ins altura numeracion / ant-osm)
  (setq ant-osm (getvar "OSMODE"))
  (setvar "OSMODE" 0)
  (princ)
  (command "_TEXT" pt-ins altura "" numeracion)
  (setvar "OSMODE" ant-osm)
) ;_ fin de defun
;;;Figura 2.8. Funcin para dibujo del texto.

;;;Define un nuevo comando de AutoCAD
;;;que dibuja nmeros incrementados por un valor fijo
(defun C:NUMERA (/ pto-ins)
  (numera-dicc)
  (setq pto-ins
         (getpoint
           (strcat "\nPosicin para el Nm. "
                   (itoa (vlax-ldata-get "VARS-NUMERA" "CIFRA"))
                   ": "
           ) ;_ fin de strcat
         ) ;_ fin de getpoint
  ) ;_ fin de setq
  (while pto-ins
    (dib-texto pto-ins
               (vlax-ldata-get "VARS-" "ALTURA")
               (itoa (vlax-ldata-get "VARS-" "CIFRA"))
    ) ;_ fin de dib-texto
    (num-prox)
    (setq pto-ins
           (getpoint
             (strcat "\nPosicin para el Nm. "
                     (itoa (vlax-ldata-get "VARS-" "CIFRA"))
                     ": "
             ) ;_ fin de strcat
           ) ;_ fin de getpoint
    ) ;_ fin de setq
  ) ;_fin de while
  (princ)
) ;_ fin de defun
;;;Figura 2.9. Funcin C:NUMERA.


(defun C:NUM-OPCIONES (/ opcion)
  (numera-dicc)
  (setq
    opcion
     (getint
       (strcat "\nNuevo incremento <"
               (itoa (vlax-ldata-get "VARS-" "INCREM"))
               ">: "
       ) ;_ fin de strcat
     ) ;_ fin de getint
  ) ;_ fin de setq
  (if opcion
    (vlax-ldata-put "VARS-" "INCREM" opcion)
  ) ;_ fin de if
  (initget "Seleccionar Teclear")
  (setq
    opcion (getkword
             "\nTeclear o <Seleccionar> el nmero inicial?: "
           ) ;_ fin de getkword
  ) ;_ fin de setq
  (cond ((= opcion "Teclear")
         (initget 1)
         (vlax-ldata-put
           "VARS-"
           "CIFRA"
           (getint "\nComenzar con: ")
         ) ;_ fin de vlax-ldata-put
        )
        (t
         (setq opcion (car (entsel "\nNumerar a continuacin de: ")))
         (if opcion
           (num-lee opcion)
         ) ;_fin de if
        )
  ) ;_ fin de cond
  (princ)
) ;_ fin de defun
;;; Figura 2.10. Funcin C:NUM-OPCIONES.

;;;Funcin que lee los datos del texto
;;;Recibe: nombre de la entidad del texto seleccionado
;;;Devuelve: el valor del texto
(defun num-lee (nom-ent)
  (while
    (and nom-ent
         (not (= (cdr (assoc 0 (entget nom-ent))) "TEXT"))
    ) ;_ fin de and
     (setq nom-ent
            (car
              (entsel "\nEsto NO es un texto, seleccione de nuevo: "
              ) ;_ fin de entsel
            ) ;_ fin de car
     ) ;_ fin de setq
  ) ;_ fin de while
  (if (and nom-ent (distof (cdr (assoc 1 (entget nom-ent)))))
    (vlax-ldata-put
      "VARS-"
      "CIFRA"
      (+ (atoi (cdr (assoc 1 (entget nom-ent))))
         (vlax-ldata-get "VARS-" "INCREM")
      ) ;_ fin de +
    ) ;_ fin de vlax-ldata-put
  ) ;_ fin de if
) ;_ fin de defun

;|Visual LISP Format Options
(67 2 40 2 T "fin de " 55 9 0 0 1 nil T nil T)
;*** NO aadir texto a continuacin del comentario! ***|;
