;;;Cdigo fuente del libro "Experto AutoCAD con Visual LISP"
;;; (c) 2012 Ediciones ARTUAL, S.L. Barcelona, Espaa.
;;; (c) 2012 Reinaldo Togores. Todos los derechos reservados
;;; Se permite su uso mencionando la obra y su autor.

;;;Captulo 23.	Medios de asociar informacin a los Objetos Grficos.

(defun ent-lee-atributos (noment / ent lista txt)
  (setq ent (entget noment))
  (if (and (equal (cdr (assoc 0 ent)) "INSERT")
           (> (cdr (assoc 66 ent)) 0)
      ) ;_ fin de and
    (progn (setq ent (entget (entnext noment)))
           (while
             (not (= (cdr (assoc 0 ent)) "SEQEND"))
              (foreach dato ent
                (if (or (= (car dato) 1)
                        (= (car dato) 3)
                    ) ;_ fin de or
                  (setq txt (cons (cdr dato) txt))
                ) ;_ fin de if
              ) ;_ fin de foreach
              (setq lista (cons
                            (cons (cdr (assoc 2 ent))
                                  (sustituye
                                    ""
                                    "\\P"
                                    (apply 'strcat
                                           (reverse txt)
                                    ) ;_ fin de apply
                                  ) ;_ fin de sustituye
                            ) ;_ fin de cons
                            lista
                          ) ;_ fin de cons
                    ent   (entget
                            (entnext (cdr (assoc -1 ent)))
                          ) ;_ fin de entget
              ) ;_ fin de setq
           ) ;_ fin de while
    ) ;_ fin de progn
  ) ;_ fin de if
  (reverse lista)
) ;_ fin de defun
;;;Listado 23.1. Funcin que lee los atributos variables de un bloque.

(defun ax-extrae-atrib
                       (bloque constante / atributos lista)
  (setq
    atributos (vlax-variant-value
                (if constante
                  (vla-getconstantattributes
                    bloque
                  ) ;_ fin de vla-getconstantattributes
                  (vla-getattributes bloque)
                ) ;_ fin de if
              ) ;_ fin de vlax-variant-value
  ) ;_ fin de setq
  (if
    (>= (vlax-safearray-get-u-bound atributos 1) 0)
     (foreach atrib
                    (vlax-safearray->list atributos)
       (setq lista
              (cons
                (cons
                  (vlax-get-property
                    atrib
                    "TagString"
                  ) ;_ fin de vlax-get-property
                  (if
                    (= (vla-get-MTextAttribute
                         atrib
                       ) ;_ fin de vla-get-MTextAttribute
                       :vlax-true
                    ) ;_ fin de =
                     (sustituye
                       ""
                       "\\P"
                       (vlax-get-property
                         atrib
                         "TextString"
                       ) ;_ fin de vlax-get-property
                     ) ;_ fin de sustituye
                     (vlax-get-property
                       atrib
                       "TextString"
                     ) ;_ fin de vlax-get-property
                  ) ;_ fin de if
                ) ;_ fin de cons
                lista
              ) ;_ fin de cons
       ) ;_ fin de setq
     ) ;_ fin de foreach
  ) ;_ fin de if
  lista
) ;_ fin de defun
;;;Listado 23.2. Funcin estndar para extraer valores de atributos.

(defun ax-lee-atributos
       (noment / bloque resultado lista)
  (setq bloque (vlax-ename->vla-object noment))
  (setq resultado (vl-catch-all-apply
                    'vla-get-HasAttributes
                    (list bloque)
                  ) ;_ fin de vl-catch-all-apply
  ) ;_ fin de setq
  (if (eq resultado :vlax-true)
    (append (reverse (ax-extrae-atrib bloque t))
            (reverse (ax-extrae-atrib bloque nil))
    ) ;_ fin de append
  ) ;_ fin de if
) ;_ fin de defun
;;;Listado 23.3. Procesamiento de un bloque para extraer una lista con sus atributos.

(defun ent-datosx (noment nomaplic lis-id lis-val / datos lista
                   objeto
                  )
  (if (not (tblsearch "appid" nomaplic))
    (regapp nomaplic)
  ) ;_ fin de if
  (setq datos
         (list
           -3
           (cons nomaplic
                 (foreach term (mapcar 'strcat
                                       lis-id
                                       lis-val
                               ) ;_ fin de mapcar
                   (setq lista
                          (append
                            lista
                            (list (cons 1000 term))
                          ) ;_ fin de append
                   ) ;_ fin de setq
                 ) ;_ fin de foreach
           ) ;_ fin de cons
         ) ;_ fin de list
  ) ;_ fin de setq
  (setq objeto (append (entget noment) (list datos)))
  (entmod objeto)
) ;_ fin de defun
;;;Listado 23.4. Asignacin de XDATA.

(defun ent-lee-datosx
                      (noment nomaplic id como-cadena / val)
  (setq id  (strcat id "=*")
        val (cdar (vl-remove-if-not
                    '(lambda (x) (wcmatch (cdr x) id))
                    (cdadr
                      (assoc
                        -3
                        (entget noment (list nomaplic))
                      ) ;_ fin de assoc
                    ) ;_ fin de cdadr
                  ) ;_ fin de vl-remove-if-not
            ) ;_ fin de cdar
  ) ;_ fin de setq
  (if val
    (progn (setq val (vl-string-left-trim id val))
           (if como-cadena
             val
             (read val)
           ) ;_ fin de if
    ) ;_ fin de progn
  ) ;_ fin de if
) ;_ fin de defun
;;;Listado 23.5. Lectura de XDATA.

(defun lista-dicc ()
  (mapcar 'cdr
          (vl-remove-if-not
            '(lambda (x) (= (car x) 3))
            (entget (namedobjdict))
          ) ;_ fin de vl-remove-if-not
  ) ;_ fin de mapcar
) ;_ fin de defun
;;;Listado 23.6. Obtencin de  la lista de todos los diccionarios.

(defun entrada-datos (/ ent nombre lista)
  (while
    (and (setq ent (car (entsel "\nDesigne entidad a nombrar: ")))
         (setq nombre (getstring t "\nIndique Nombre: "))
         (not (= nombre ""))
    ) ;_ fin de and
     (setq lista
            (cons (cons (cdr (assoc 5 (entget ent))) nombre)
                  lista
            ) ;_ fin de cons
     ) ;_ fin de setq
  ) ;_ fin de while
  lista
) ;_ fin de defun
;;;Listado 23.7. Funcin para solicitar los datos al usuario.

(defun crea-dicc (nombre)
  (if (not (member nombre (lista-dicc)))
    (dictadd
      (namedobjdict)
      nombre
      (entmakex
        '((0 . "DICTIONARY") (100 . "AcDbDictionary"))
      ) ;_ fin de entmakex
    ) ;_ fin de dictadd
    (cdr (assoc -1 (dictsearch (namedobjdict) nombre)))
  ) ;_ fin de if
) ;_ fin de defun
;;;Listado 23.8. Funcin que crea el diccionario o recupera su ENAME en caso de existir.

(defun nuevos-registros (ent-dicc lista-datos / xrec)
  (foreach dato lista-datos
    (if (dictsearch ent-dicc (car dato))
      (entdel (dictremove ent-dicc (car dato)))
    ) ;_ fin de if
    (if
      (setq xrec
             (entmakex
               (list
                 '(0 . "XRECORD")
                 '(100 . "AcDbXrecord")
                 (cons 1 (cdr dato))
               ) ;_ fin de list
             ) ;_ fin de entmakex
      ) ;_ fin de setq
       (dictadd ent-dicc (car dato) xrec)
       (prompt "\error en adicin de campo")
    ) ;_ fin de if
  ) ;_ fin de foreach
) ;_ fin de defun
;;;Listado 23.9. Adicin de nuevos registros al diccionario.

(defun C:TOPONIMICOS (/ datos dicc)
  (cond
    ((setq dicc (dictsearch (namedobjdict) "TOPONIMICOS"))
     (setq dicc (cdr (assoc -1 dicc)))
    )
    ((setq dicc (crea-dicc "TOPONIMICOS")))
    (t
     (prompt
       "\nError en la creacin del diccionario TOPONOIMICOS"
     ) ;_ fin de prompt
    )
  ) ;_ fin de cond
  (if (and dicc (setq datos (entrada-datos)))
    (nuevos-registros dicc datos)
    (alert "Se ha producido un error en la aplicacin")
  ) ;_ fin de if
  (princ)
) ;_ fin de defun
;;;Listado 23.10. Comando C:TOPONIMICOS.

(defun C:IDENTIFICA (/ dicc ent nom)
  (if (and (setq dicc (dictsearch
                        (namedobjdict)
                        "TOPONIMICOS"
                      ) ;_ fin de dictsearch
           ) ;_ fin de setq
           (setq dicc (cdr (assoc -1 dicc)))
      ) ;_ fin de and
    (while (setq ent
                  (car
                    (entsel
                      "\nDesigne entidad a identificar: "
                    ) ;_ fin de entsel
                  ) ;_ fin de car
           ) ;_ fin de setq
      (if (setq
            nom (dictsearch
                  dicc
                  (cdr (assoc 5 (entget ent)))
                ) ;_ fin de dictsearch
          ) ;_ fin de setq
        (alert
          (strcat
            "La entidad seleccionada representa\n"
            (cdr (assoc 1 nom))
          ) ;_ fin de strcat
        ) ;_ fin de alert
        (alert
          "La entidad no tiene\nnombre asignado."
        ) ;_ fin de alert
      ) ;_ fin de if
    ) ;_ fin de while
  ) ;_ fin de if
) ;_ fin de defun
;;;Listado 23.11. Funcin para consulta de los datos asociados.

(defun C:BORRA-NOMBRE  (/ dicc ent)
  (if (and (setq dicc (dictsearch (namedobjdict) "TOPONIMICOS"))
           (setq dicc (cdr (assoc -1 dicc))))
    (setq ent (car (entsel "\nSeleccione la entidad cuyo nombre desea eliminar: "))))
    (setq ent (cdr (assoc 5 (entget ent))))
    (if (dictsearch dicc ent)
      (entdel (dictremove dicc ent))
      (alert
        "La entidad no tiene\nnombre asignado.")))
;;;Listado 23.11a. Funcin que elimina el toponmico asociado.

(defun lista->ldata (dicc lista)
  (foreach sublista lista
    (if (listp sublista)
      (vlax-ldata-put
        dicc
        (vl-princ-to-string (car lista))
        (cdr sublista)
      ) ;_ fin de vlax-ldata-put
    ) ;_ fin de if
  ) ;_ fin de foreach
) ;_ fin de defun
;;;Listado 23.12. Funcin lista->ldata.

(defun lista->ldata (dicc lista)
  (foreach sublista lista
    (if (and (listp sublista) (vlax-ldata-test (cdr sublista)))
      (vlax-ldata-put
        dicc
        (vl-princ-to-string (car sublista))
        (cdr sublista)
      ) ;_ fin de vlax-ldata-put
    ) ;_ fin de if
  ) ;_ fin de foreach
) ;_ fin de defun
;;;Listado 23.13. Funcin LISTA->LDATA incorporando VLAX-LDATA-TEST.

(defun asocia (ent-ppal ent-asoc clave)
  (vlax-ldata-put ent-ppal clave ent-asoc)
) ;_ fin de defun
;;;Listado 23.14. Funcin para asociar entidades mediante LDATA.

(defun localiza-ADO-CAO (/ dir lcid CAOdir ADOdir)
  (setq dir    (getenv "COMMONPROGRAMFILES")
        lcid   (getvar "LOCALE")
        ADOdir (findfile
                 (strcat dir "\\system\\ado\\msado15.dll")
               ) ;_ fin de findfile
        CAOdir (findfile (strcat dir
                                 "\\AUTODESK SHARED\\"
                                 (if (wcmatch lcid "ES*")
                                   "cao16esp.tlb"
                                   "cao16enu.tlb"
                                 ) ;_ fin de if
                         ) ;_ fin de strcat
               ) ;_ fin de findfile
  ) ;_ fin de setq
  (list ADOdir CAOdir)
) ;_ fin de defun
;;;Listado 23.15. Funcin que busca las trayectorias de las bibliotecas.

(defun importa-ADO-CAO (/ bibl)
  (vl-load-com)
  (setq bibl (localiza-ADO-CAO))
  (if (car bibl)
    (cond ((vl-member-if
             '(lambda (x) (wcmatch x "ADOM-*"))
             (atoms-family 1)
           ) ;_ fin de vl-member-if
           t
          )
          (t
           (vlax-import-type-library
             :tlb-filename
             (car bibl)
             :methods-prefix
             "adoM-"
             :properties-prefix
             "adoP-"
             :constants-prefix
             "adoC-"
           ) ;_ fin de vlax-import-type-library
          )
    ) ;_ fin de cond
    (prompt
      "\nERROR: No se encontr la biblioteca ADO"
    ) ;_ fin de prompt
  ) ;_ fin de if
  (if (last bibl)
    (cond ((vl-member-if
             '(lambda (x) (wcmatch x "CAOM-*"))
             (atoms-family 1)
           ) ;_ fin de vl-member-if
           t
          )
          (t
           (vlax-import-type-library
             :tlb-filename
             (last bibl)
             :methods-prefix
             "caoM-"
             :properties-prefix
             "caoP-"
             :constants-prefix
             "caoC-"
           ) ;_ fin de vlax-import-type-library
          )
    ) ;_ fin de cond
    (prompt
      "\nERROR: No se encontr la biblioteca CAO."
    ) ;_ fin de prompt
  ) ;_ fin de if
) ;_ fin de defun
;;;Listado 23.16. Funcin que importa bibliotecas de componentes.

;|Visual LISP Format Options
(67 2 40 2 T "fin de " 55 9 0 0 1 nil T nil T)
;*** NO aadir texto a continuacin del comentario! ***|;
