;;;Cdigo fuente del libro "Experto AutoCAD con Visual LISP"
;;; (c) Ediciones ARTUAL, S.L. Barcelona, Espaa.
;;; (c) 2012 Reinaldo Togores. Todos los derechos reservados
;;; Se permite su uso mencionando la obra y su autor.

;;;Captulo 5.	Funciones definidas por el usuario.


;;;5.2	Cargar y ejecutar funciones de usuario.------------------

(defun cap-i-cua (x y z) (strcat x y z y x))
;;;Listado 5.1. Cdigo de la funcin CAP-I-CUA.



;;;5.3	Variables globales y locales.----------------------------

(defun mensaje-1 (/ x)
  (setq x "SEGUNDA")
  (princ. "\n Mensaje-1 asigna a x ")
  (princ. x)
  (princ. "\n Pero z sigue ")
  (princ. z)
) ;_ fin de defun

(defun mensaje-2 (/ x)
  (setq x "TERCERA")
  (princ "\n Mensaje-2 asigna a x ")
  (princ x)
  (princ "\n Pero z sigue ")
  (princ z)
) ;_ fin de defun

(defun mensajes (/ x z)
  (setq x "PRIMERA"
        z "SIN CAMBIOS"
  ) ;_ fin de setq
  (princ "\n mensajes asigna a la variable x ")
  (princ x)
  (princ "\n y a la variable z ")
  (princ z)
  (mensaje-1)
  (mensaje-2)
  (princ "\n y de regreso a mensajes, x contiene ")
  (princ x)
  (princ "\n y como siempre, z ")
  (princ z)
  (princ)
) ;_ fin de defun
;;;Listado 5.2. Demostracin con variables locales.


;;;5.4	Predicados y Condicionales.------------------------------

(defun par-punteado-p (arg)
  (and (vl-consp arg) (atom (cdr arg)))
) ;_ fin de defun
;;;Listado 5.3. Predicado PAR-PUNTEADO-P.

(defun stringp (arg)
  (eq (type arg) 'STR)
) ;_ fin de defun
;;;Listado 5.4. Predicado STRINGP.

(defun lista? (arg / resultado)
  (if (listp arg)
    (setq resultado "S")
    (setq resultado "No")
  ) ;_ fin de if
  (princ (strcat resultado " es una lista"))
  (princ)
) ;_ fin de defun
;;;Listado 5.5. Funcin LISTA? con asignacin a variables locales.

(defun lista? (arg)
  (princ
    (strcat
      (if (listp arg)
        "S"
        "No"
      ) ;_ fin de if
      " es una lista"
    ) ;_ fin de strcat
  ) ;_ fin de princ
  (princ)
) ;_ fin de defun
;;;Listado 5.6. Funcin LISTA? sin variables locales.

(defun tipo? (arg)
  (cond ((listp arg)
         (princ arg)
         (princ " es una lista")
        )
        ((vl-symbolp arg)
         (princ arg)
         (princ " es un smbolo")
        )
        ((and (numberp arg) (zerop arg))
         (princ arg)
         (princ " es el nmero cero")
        )
        ((and (numberp arg) (minusp arg))
         (princ arg)
         (princ " es un nmero negativo")
        )
        ((numberp arg)
         (princ arg)
         (princ " es un nmero positivo")
        )
        (t
         (princ "no sabemos qu es ")
         (princ arg)
        )
  ) ;_ fin de cond
  (princ)
) ;_ fin de defun
;;;Listado 5.7. Funcin TIPO?.

(defun ordena-lista (lista funcion)
  (mapcar '(lambda (x) (nth x lista))
          (vl-sort-i lista funcion)
  ) ;_ fin de mapcar
) ;_ fin de defun
;;;Listado 5.8. Funcin para ordenar listas.

(defun ordena-puntos (lista-puntos coordenada)
  (mapcar '(lambda (x) (nth x lista-puntos))
          (vl-sort-i
            lista-puntos
            '(lambda (x y)
               (< (nth coordenada x) (nth coordenada y))
             ) ;_ fin de lambda
          ) ;_ fin de vl-sort-i
  ) ;_ fin de mapcar
) ;_ fin de defun
;;;Listado 5.9. Ordenar lista de puntos segn una de sus coordenadas.

(defun ordena-cadenas (cadena funcion)
  (apply 'strcat
         (mapcar 'chr
                 (ordena-lista
                   (vl-string->list cadena)
                   funcion
                 ) ;_ fin de ordena-lista
         ) ;_ fin de mapcar
  ) ;_ fin de apply
) ;_ fin de defun
;;;Listado 5.10. Funcin que ordena cadenas de caracteres.

(defun ordena-frase (frase funcion)
  (ordena-lista
    (mapcar 'vl-princ-to-string
            (read (strcat "(" frase ")"))
    ) ;_ fin de mapcar
    funcion
  ) ;_ fin de ordena-lista
) ;_ fin de defun
;;;Listado 5.11. Funcin que ordena las palabras en una frase.

(defun sustituye (nuevo viejo cadena)
  (while (vl-string-search viejo cadena)
    (setq cadena (vl-string-subst nuevo viejo cadena))
  ) ;_ fin de while
) ;_ fin de defun
;;;Listado 5.12. Sustitucin de caracteres en una cadena.

(defun ordenar-frases-como-cadenas (frase / lista-frase)
  (acad_strlsort
    (setq lista-frase
           (read
             (strcat "(\""
                     (sustituye "\"\"" " " frase)
                     "\")"
             ) ;_ fin de strcat
           ) ;_ fin de read
    ) ;_ fin de setq
  ) ;_ fin de acad_strlsort
) ;_ fin de defun
;;;Listado 5.13. Funcin para ordenar palabras contenidas en frases.


;;;5.5	Recursin---------------------------------------------------

(defun factorial (n)
  (cond ((zerop n) 1)
        (t (* n (factorial (- n 1))))
  ) ;_ fin de cond
) ;_ fin de defun
;;;Listado 5.14. Factorial de un nmero.

(defun cuenta-miembros (elem lista)
  (cond
    ((null (member elem lista)) 0)
    (t
     (+ 1
        (cuenta-miembros elem (cdr (member elem lista)))
     ) ;_ fin de +
    )
  ) ;_ fin de cond
) ;_ fin de defun
;;;Listado 5.15. Funcin para contar miembros de una lista.

(defun miembro (elem lista)
  (cond
    ((null lista) nil)
    ((equal (car lista) elem) lista)
    (t (miembro elem (cdr lista)))
  ) ;_ fin de cond
) ;_ fin de defun
;;;Listado 5.16. Definicin recursiva de la funcin member.

(defun aplana (lista)
  (cond
    ((atom lista) (list lista))
    (t
     (append
       (aplana (car lista))
       (aplana (cdr lista))
     ) ;_ fin de append
    )
  ) ;_ fin de cond
) ;_ fin de defun
;;;Listado 5.17. Funcin para aplanar listas anidadas.

(defun aplana (lista)
  (cond
    ((null lista) nil)
    ((atom lista) (list lista))
    (t
     (append
       (aplana (car lista))
       (aplana (cdr lista))
     ) ;_ fin de append
    )
  ) ;_ fin de cond
) ;_ fin de defun
;;;Listado 5.18. Funcin aplana eliminando trminos nil.

;;;5.6	Iteracin----------------------------------------------------

(defun fibonacci (cuantos / serie prox)
  (setq serie '(1)
        prox  1
  ) ;_ fin de setq
  (repeat (- cuantos 1)
    (setq serie (cons prox serie)
          prox  (+ (car serie) (cadr serie))
    ) ;_ fin de setq
  ) ;_ fin de repeat
  (reverse serie)
) ;_ fin de defun
;;;Listado 5.19. Funcin FIBONACCI implementada con REPEAT.

(defun cap-i-cua-p (cadena / cont resultado)
  (setq cont 0
        resultado t
  ) ;_ fin de setq
  (repeat (/ (strlen cadena) 2)
    (if
      (not
        (equal
          (strcase (substr cadena (1+ cont) 1))
          (strcase
            (substr cadena (- (strlen cadena) cont) 1)
          ) ;_ fin de strcase
        ) ;_ fin de equal
      ) ;_ fin de not
       (setq resultado nil)
    ) ;_ fin de if
    (setq cont (1+ cont))
  ) ;_ fin de repeat
  resultado
) ;_ fin de defun
;;;Listado 5.20. Predicado CAP-I-CUA-P (usando repeat).

(defun imprime-lista (lista /)
  (foreach term lista (print term))
  (princ)
) ;_ fin de defun
;;;Listado 5.21. Impresin de lista (con FOREACH).

(defun imprime-lista (lista /)
  (mapcar 'print lista)
  (princ)
) ;_ fin de defun
;;;Listado 5.22. Impresin de lista (con MAPCAR).

(defun cuadrados-1 (lista)
  (mapcar '(lambda (term) (* term term)) lista)
) ;_ fin de defun
;;;Listado 5.23. Cuadrados de una lista (con mapcar).

(defun cuadrados-2 (lista)
  (cond
    ((null lista) nil)
    (t
     (cons (* (car lista) (car lista))
           (cuadrados-2 (cdr lista))
     ) ;_ fin de cons
    )
  ) ;_ fin de cond
) ;_ fin de defun
;;;Listado 5.24. Cuadrados de una lista (recursiva).

(defun cuadrados-3 (lista / resultado)
  (setq resultado nil)
  (foreach term lista
    (setq resultado (cons (* term term) resultado))
  ) ;_ fin de foreach
  (reverse resultado)
) ;_ fin de defun
;;;Listado 5.25. Cuadrados de una lista (foreach).

(defun cuenta-entidades (/ cont ent)
  (setq cont 0
        ent  (entnext)
  ) ;_ fin de setq
  (while ent
    (setq cont (1+ cont)
          ent  (entnext ent)
    ) ;_ fin de setq
  ) ;_ fin de while
  cont
) ;_ fin de defun
;;;Listado 5.26. Conteo de entidades.

(defun cap-i-cua-p (cadena / cont resultado)
  (setq cont 0
        resultado t
  ) ;_ fin de setq
  (while (and (<= cont (/ (strlen cadena) 2)) resultado)
    (if
      (not
        (equal (substr cadena (1+ cont) 1)
               (substr cadena (- (strlen cadena) cont) 1)
        ) ;_ fin de equal
      ) ;_ fin de not
       (setq resultado nil)
    ) ;_ fin de if
    (setq cont (1+ cont))
  ) ;_ fin de while
  resultado
) ;_ fin de defun
;;;Listado 5.27. Predicado CAP-I-CUA-P (con while).

(defun lista-nombres (tabla / nombre tmp)
  (setq tmp (cons (cdr (assoc 2 (tblnext tabla t))) tmp))
  (while (setq nombre (cdr (assoc 2 (tblnext tabla))))
    (setq tmp (cons nombre tmp))
  ) ;_ fin de while
  (acad_strlsort tmp)
) ;_ fin de defun
;;;Listado 5.28. Obtencin de los nombres de elementos contenidos en las tablas de smbolos.
;|Visual LISP Format Options
(67 2 40 2 T "fin de " 55 9 0 0 1 nil T nil T)
;*** NO aadir texto a continuacin del comentario! ***|;
