;;;Cdigo fuente del libro "Experto AutoCAD con Visual LISP"
;;; (c) Ediciones ARTUAL, S.L. Barcelona, Espaa.
;;; (c) 2012 Reinaldo Togores. Todos los derechos reservados
;;; Se permite su uso mencionando la obra y su autor.

;;;Captulo 8.	Operaciones con archivos.

(defun lee-letras (archivo / id-archivo textos)
  (if (setq id-archivo (open (findfile archivo) "r"))
    (progn (setq textos "")
           (while (setq letra (read-char id-archivo))
             (setq textos (strcat texto (chr letra)))
           ) ;_ fin de while
           (close id-archivo)
           (alert textos)
    ) ;_ fin de progn
  ) ;_ fin de if
) ;_ fin de defun
;;;Listado 8.1. Lectura de un archivo letra a letra.


(defun archivo->lista (archivo / id-archivo tmp)
  (if (setq id-archivo (open archivo "r"))
    (while (setq linea (read-line id-archivo))
      (setq tmp (cons (read (strcat "(" linea ")")) tmp))
    ) ;_ fin de while
    (close id-archivo)
  ) ;_ fin de if
  (reverse tmp)
) ;_ fin de defun
;;;Listado 8.2. Lectura de un archivo a una lista.

(defun lista->csv (lista delim archivo anexar / id-archivo)
  (if (setq id-archivo
             (open archivo
                   (if anexar
                     "a"
                     "w"
                   ) ;_ fin de if
             ) ;_ fin de open
      ) ;_ fin de setq
    (progn (foreach sublista lista
             (while (setq valor (car sublista))
               (prin1 valor id-archivo)
               (if (setq sublista (cdr sublista))
                 (princ delim id-archivo)
               ) ;_ fin de if
             ) ;_ fin de while
             (write-char 10 id-archivo)
           ) ;_ fin de foreach
           (close id-archivo)
    ) ;_ fin de progn
  ) ;_ fin de if
) ;_ fin de defun
;;;Listado 8.3. Funcin lista->csv.

(defun lista->textos (lista prec)
  (mapcar '(lambda (x)
             (mapcar '(lambda (y)
                        (if (numberp y)
                          (rtos y 2 prec)
                          (vl-princ-to-string y)
                        ) ;_ fin de if
                      ) ;_ fin de lambda
                     x
             ) ;_ fin de mapcar
           ) ;_ fin de lambda
          lista
  ) ;_ fin de mapcar
) ;_ fin de defun
;;;Listado 8.4. Conversin de elementos de listas a textos.

(defun long-cadena (carcter cadena long / veces)
  (setq veces (- long (strlen cadena)))
  (cond ((zerop veces) cadena)
        ((minusp veces) (substr cadena 1 long))
        (t
         (repeat veces
           (setq cadena (strcat cadena carcter))
         ) ;_ fin de repeat
        )
  ) ;_ fin de cond
) ;_ fin de defun
;;;Listado 8.5. Llevar una cadena a una longitud fija.


(defun lista->sdf (lista long prec carcter archivo anexar /
                   id-archivo tmp
                  )
  (if (setq id-archivo
             (open archivo
                   (if anexar
                     "a"
                     "w"
                   ) ;_ fin de if
             ) ;_ fin de open
      ) ;_ fin de setq
    (progn (setq lista (lista->textos lista prec))
           (foreach sublista lista
             (setq tmp "")
             (foreach valor sublista
               (setq tmp
                      (strcat
                        tmp
                        (long-cadena carcter valor long)
                      ) ;_ fin de strcat
               ) ;_ fin de setq
             ) ;_ fin de foreach
             (write-line tmp id-archivo)
           ) ;_ fin de foreach
           (close id-archivo)
    ) ;_ fin de progn
  ) ;_ fin de if
) ;_ fin de defun
;;;Listado 8.6. Funcin LISTA->SDF.

(defun existe-archivo? (nombre carpeta)
  (vl-directory-files carpeta nombre 1)
) ;_ fin de defun
;;;Listado 8.7. Funcin para bsqueda de un archivo.

(defun unidades (/ cdigo tmp)
  (setq cdigo 65)
  (while (<= cdigo 90)
    (if (vl-directory-files (strcat (chr cdigo) ":"))
      (setq tmp (cons (strcat (chr cdigo) ":") tmp))
    ) ;_ fin de if
    (setq cdigo (1+ cdigo))
  ) ;_ fin de while
  (reverse tmp)
) ;_ fin de defun
;;;Listado 8.8. Funcin para reconocer unidades de disco disponibles.

(defun crea-lista-puntos (/ pt tmp)
  (while (setq pt (getpoint "\nDesigne Punto: "))
    (setq tmp (cons pt tmp))
  ) ;_ fin de while
  tmp
) ;_ fin de defun
;;;Listado 8.9. Funcin CREA-LISTA-PUNTOS para crear una lista de coordenadas.

;|Visual LISP Format Options
(67 2 40 2 T "fin de " 55 9 0 0 1 nil T nil T)
;*** NO aadir texto a continuacin del comentario! ***|;
