;;;Cdigo fuente del libro "Experto AutoCAD con Visual LISP"
;;; (c) 2012 Ediciones ARTUAL, S.L. Barcelona, Espaa.
;;; (c) 2012 Reinaldo Togores. Todos los derechos reservados
;;; Se permite su uso mencionando la obra y su autor.


(defun reactor-ventana (ventana)
  (vlr-pers
    (VLR-Object-Reactor
      (list ventana)
      (list (getvar "CTAB") (vla-get-Handle ventana))
      '((:VLR-objectClosed . respuesta-ventana))
    ) ;_ fin de VLR-Object-Reactor
  ) ;_ fin de vlr-pers
) ;_ fin de defun
;;;Listado 21.5. Creacin del reactor de Objeto.

(defun reactor-comando (ventana)
  (vlr-pers
    (vlr-command-reactor
      (list (getvar "ctab") (vla-get-handle ventana))
      '((:vlr-commandWillStart . respuesta-inicio-comando)
        (:vlr-commandEnded . respuesta-fin-comando)
       )
    ) ;_ fin de vlr-command-reactor
  ) ;_ fin de vlr-pers
) ;_ fin de defun
;;;Listado 21.6. Creacin del reactor de Comando.

(defun C:AUTO-ESCALA (/ vgraf obj-vgraf)
  (cond
    ((/= (getvar "ctab") "Model")
     (prompt
       "\nDesigne ventana para auto-escala de textos:\n"
     ) ;_ fin de prompt
     (while (not (setq vgraf
                        (ssget "_:S" '((0 . "VIEWPORT")))
                 ) ;_ fin de setq
            ) ;_ fin de not
     ) ;_ fin de while
     (setq obj-vgraf (vlax-ename->vla-object
                       (ssname vgraf 0)
                     ) ;_ fin de vlax-ename->vla-object
     ) ;_ fin de setq
     (if (not (propietario? obj-vgraf))
       (progn (reactor-ventana obj-vgraf)
              (reactor-comando obj-vgraf)
       ) ;_ fin de progn
       (alert "Esta ventana ya tiene reactores.")
     ) ;_ fin de if
    )
    (t
     (alert
       "Este comando vlido slo\nen Espacio Papel."
     ) ;_ fin de alert
    )
  ) ;_ fin de cond
) ;_ fin de defun
;;;Listado 21.7. C:AUTO-ESCALA. Interfaz de usuario para creacin de los reactores.

(defun propietario? (objeto / reactores)
  (if (setq
        reactores (mapcar 'cadr
                          (vlr-reactors
                            :VLR-Object-Reactor
                          ) ;_ fin de vlr-reactors
                  ) ;_ fin de mapcar
      ) ;_ fin de setq
    (apply 'or
           (mapcar
             '(lambda (x)
                (if (member objeto (vlr-owners x))
                  t
                ) ;_ fin de if
              ) ;_ fin de lambda
             reactores
           ) ;_ fin de mapcar
    ) ;_ fin de apply
  ) ;_ fin de if
) ;_ fin de defun
;;;Listado 21.8. Funcin que determina si un objeto tiene vinculados reactores.

;|Visual LISP Format Options
(67 2 40 2 T "fin de " 55 9 0 0 1 nil T nil T)
;*** NO aadir texto a continuacin del comentario! ***|;
