;;;Cdigo fuente del libro "Experto AutoCAD con Visual LISP"
;;; (c) 2012 Ediciones ARTUAL, S.L. Barcelona, Espaa.
;;; (c) 2012 Reinaldo Togores. Todos los derechos reservados
;;; Se permite su uso mencionando la obra y su autor.


(defun usar? (capa)
  (zerop
    (logand (cdr (assoc 70 (tblsearch "layer" capa)))
            (+ 1 4)
    ) ;_ fin de logand
  ) ;_ fin de zerop
) ;_ fin de defun
;;;Listado 10.36. Comprueba si una capa no est inutilizada ni bloqueada.

(defun procesa-textos (obj-notif / sel-texto nueva-escala alt-texto
                       i texto
                      )
  (setq sel-texto    (ssget "X"
                            '((0 . "TEXT") (410 . "Model"))
                     ) ;_ fin de ssget
        nueva-escala (vla-get-CustomScale obj-notif)
        alt-texto    (* (getvar "textsize")
                        (/ 1 nueva-escala)
                     ) ;_ fin de *
        i            0
  ) ;_ fin de setq
  (while (setq texto (ssname sel-texto i))
    (setq texto (vlax-ename->vla-object texto))
    (if (and (vlax-write-enabled-p texto)
             (usar? (vla-get-Layer texto))
             (/= (vla-get-height texto) alt-texto)
        ) ;_ fin de and
      (vla-put-Height texto alt-texto)
    ) ;_ fin de if
    (setq i (1+ i))
  ) ;_ fin de while
) ;_ fin de defun
;;;Listado 21.1. Funcin que procesa los textos.

(defun respuesta-ventana (obj-notif obj-react lis-param)
  (if
    (and (not *ComandoActivo*)
         (vlax-read-enabled-p obj-notif)
         (= (getvar "ctab") (car (vlr-data obj-react)))
    ) ;_ fin de and
     (procesa-textos obj-notif)
  ) ;_ fin de if
) ;_ fin de defun
;;;Listado 21.2. Funcin de respuesta a la modificacin de la ventana grfica.

(defun respuesta-inicio-comando (obj-react lis-param)
  (setq *ComandoActivo* t)
) ;_ fin de defun
;;;Listado 21.3. Funcin de respuesta al inicio de un comando.

(defun respuesta-fin-comando
                             (obj-react lis-param / obj-vgraf)
  (setq *ComandoActivo* nil
        obj-vgraf
                        (vlax-ename->vla-object
                          (handent (cadr (vlr-data obj-react)))
                        ) ;_ fin de vlax-ename->vla-object
  ) ;_ fin de setq
  (if (and (= (car lis-param) "PSPACE")
           (vlax-read-enabled-p obj-vgraf)
           (/= (getvar "CTAB") "Model")
      ) ;_ fin de and
    (procesa-textos obj-vgraf)
  ) ;_ fin de if
) ;_ fin de defun
;;;Listado 21.4. Funcin de respuesta al fin de un comando.

;|Visual LISP Format Options
(67 2 40 2 T "fin de " 55 9 0 0 1 nil T nil T)
;*** NO aadir texto a continuacin del comentario! ***|;
