;;;Cdigo fuente del libro "Experto AutoCAD con Visual LISP"
;;; (c) Ediciones ARTUAL, S.L. Barcelona, Espaa.
;;; (c) 2012 Reinaldo Togores. Todos los derechos reservados
;;; Se permite su uso mencionando la obra y su autor.

;;;Figura 2.9. Funcin C:NUMERA.
;;;Define un nuevo comando de AutoCAD
;;;que dibuja nmeros incrementados por un valor fijo
(defun C:NUMERA (/ pto-ins)
  (numera-dicc)
  (setq pto-ins (getpoint
                  (strcat "\nPosicin para el Nm. "
                          (itoa (vlax-ldata-get "VARS-NUMERA" "CIFRA"))
                          ": "
                  ) ;_ fin de strcat
                ) ;_ fin de getpoint
  ) ;_ fin de setq
  (while pto-ins
    (dib-texto pto-ins
               (vlax-ldata-get "VARS-NUMERA" "ALTURA")
               (itoa (vlax-ldata-get "VARS-NUMERA" "CIFRA"))
    ) ;_ fin de dib-texto
    (num-prox)
    (setq pto-ins
           (getpoint
             (strcat "\nPosicin para el Nm. "
                     (itoa (vlax-ldata-get "VARS-NUMERA" "CIFRA"))
                     ": "
             ) ;_ fin de strcat
           ) ;_ fin de getpoint
    ) ;_ fin de setq
  ) ;_fin de while
  (princ)
) ;_ fin de defun


;;; Figura 2.10. Funcin C:NUM-OPCIONES.
(defun C:NUM-OPCIONES (/ opcion)
  (numera-dicc)
  (setq
    opcion (getint (strcat "\nNuevo incremento <"
                           (itoa (vlax-ldata-get "VARS-NUMERA" "INCREM"))
                           ">: "
                   ) ;_ fin de strcat
           ) ;_ fin de getint
  ) ;_ fin de setq
  (if opcion
    (vlax-ldata-put "VARS-NUMERA" "INCREM" opcion)
  ) ;_ fin de if
  (initget "Seleccionar Teclear")
  (setq
    opcion (getkword "\nTeclear o <Seleccionar> el nmero inicial?: ")
  ) ;_ fin de setq
  (cond ((= opcion "Teclear")
         (initget 1)
         (vlax-ldata-put "VARS-NUMERA" "CIFRA" (getint "\nComenzar con: "))
        )
        (t
         (setq opcion (car (entsel "\nNumerar a continuacin de: ")))
         (if opcion
           (num-lee opcion)
         ) ;_fin de if
        )
   ) ;_ fin de cond
  (princ)
) ;_ fin de defun

;;;Figura 2.11. Funcin num-lee.
;;;Funcin que lee los datos del texto
;;;Recibe: nombre de la entidad del texto seleccionado
;;;Devuelve: el valor del texto
(defun num-lee (nom-ent)
  (while
    (and nom-ent (not (= (cdr (assoc 0 (entget nom-ent))) "TEXT")))
    (setq nom-ent
           (car
             (entsel "\nEsto NO es un texto, seleccione de nuevo: "
             ) ;_ fin de entsel
           ) ;_ fin de car
    ) ;_ fin de setq
  ) ;_ fin de while
  (if (and nom-ent (distof (cdr (assoc 1 (entget nom-ent)))))
    (vlax-ldata-put
      "VARS-NUMERA"
      "CIFRA"
      (+ (atoi (cdr (assoc 1 (entget nom-ent))))
         (vlax-ldata-get "VARS-NUMERA" "INCREM")
      ) ;_ fin de +
    ) ;_ fin de vlax-ldata-put
  ) ;_ fin de if
) ;_ fin de defun
