;;;Cdigo fuente del libro "Experto AutoCAD con Visual LISP"
;;; (c) 2012 Ediciones ARTUAL, S.L. Barcelona, Espaa.
;;; (c) 2012 Reinaldo Togores. Todos los derechos reservados
;;; Se permite su uso mencionando la obra y su autor.

(defun C:XCAPA (/)
  (command "_OPENDCL")
  (dcl_loadproject "./XCapa/XCapa.odcl" t)
  (dcl_form_show XCapa_frmPal)
) ;_ fin de defun
;;;Listado 27.1. Funcin que implementa el nuevo comando XCAPA.


;;;(defun c:XCapa_frmPal_OnInitialize (/)
;;;  (dcl_MessageBox "To Do: code must be added to event handler\r\nc:XCapa_frmPal_OnInitialize" "To do")
;;;)

;;;(defun c:XCapa_frmPal_OnDocActivated (/)
;;;  (dcl_MessageBox "To Do: code must be added to event handler\r\nc:XCapa_frmPal_OnDocActivated" "To do")
;;;)

;;;(defun c:XCapa_frmPal_OnEnteringNoDocState (/)
;;;  (dcl_MessageBox "To Do: code must be added to event handler\r\nc:XCapa_frmPal_OnEnteringNoDocState" "To do")
;;;)

;;;(defun c:XCapa_frmPal_trcCapas_OnSelChanged (Label Key /)
;;;  (dcl_MessageBox "To Do: code must be added to event handler\r\nc:XCapa_frmPal_trcCapas_OnSelChanged" "To do")
;;;)

(defun lis-dib (/ col-bloques lst-xref)
  (setq col-bloques (vla-get-Blocks *aesl:dibujo*))
  (vlax-for bloque col-bloques
    (if (equal (vla-get-IsXref bloque) :vlax-true)
      (setq lst-xref
             (cons (vla-get-name bloque) lst-xref)
      ) ;_ fin de setq
    ) ;_ fin de if
  ) ;_ fin de vlax-for
  (setq lst-xref (acad_strlsort lst-xref)
        lst-xref (cons (getvar "DWGNAME") lst-xref)
  ) ;_ fin de setq
) ;_ fin de defun
;;;Listado 27.3. Funcin que obtiene la lista de dibujos insertados.

(defun lis-capa (/ col-capas lst-capas)
  (setq col-capas (vla-get-Layers *aesl:dibujo*))
  (vlax-for capa col-capas
    (setq lst-capas (cons (vla-get-Name capa) lst-capas))
  ) ;_ fin de vlax-for
  (acad_strlsort lst-capas)
) ;_ fin de defun
;;;Listado 27.4. Funcin que obtiene la lista de capas.

(defun dib-capa
                (dibujos capas / actual tmp0 tmp1 res0 res1)
  (setq actual (getvar "dwgname"))
  (foreach dibujo dibujos
    (foreach capa capas
      (cond ((setq pos (vl-string-search "|" capa))
             (if (wcmatch capa (strcat dibujo "|*"))
               (setq tmp0
                      (cons (substr capa (+ pos 2)) tmp0)
               ) ;_ fin de setq
             ) ;_ fin de if
            )
            (t
             (if (= dibujo actual)
               (setq tmp1 (cons capa tmp1))
             ) ;_ fin de if
            )
      ) ;_ fin de cond
    ) ;_ fin de foreach
    (cond (tmp1
           (setq res1
                  (cons (cons actual (acad_strlsort tmp1))
                        res1
                  ) ;_ fin de cons
           ) ;_ fin de setq
          )
          (tmp0
           (setq res0
                  (cons (cons dibujo (acad_strlsort tmp0))
                        res0
                  ) ;_ fin de cons
           ) ;_ fin de setq
          )
    ) ;_ fin de cond
    (setq tmp0 nil
          tmp1 nil
    ) ;_ fin de setq
  ) ;_ fin de foreach
  (append res1 (reverse res0))
) ;_ fin de defun
;;;Listado 27.5. Funcin que crea la lista de asociacin de dibujos y capas.

(defun crea-nodos (arbol / res_raiz res_refx id-img sel-img res_capa)
  (setq res_raiz (dcl_tree_addparent XCapa_frmPal_trcCapas "Todo"))
  (dcl_tree_setitemimages
    XCapa_frmPal_trcCapas
    res_raiz
    0
    1
  ) ;_ fin de dcl_tree_setitemimages
  (foreach refx arbol
    (setq res_refx (dcl_tree_addchild
                     XCapa_frmPal_trcCapas
                     res_raiz
                     (car refx)
                   ) ;_ fin de dcl_tree_addchild
    ) ;_ fin de setq
    (if (= (getvar "dwgname") (car refx))
      (setq id-img 2
            sel-img 3
      ) ;_ fin de setq
      (setq id-img 4
            sel-img 5
      ) ;_ fin de setq
    ) ;_ fin de if
    (dcl_tree_setitemimages
      XCapa_frmPal_trcCapas
      res_refx
      id-img
      sel-img
    ) ;_ fin de dcl_tree_setitemimages
    (foreach capa (cdr refx)
      (setq res_capa (dcl_tree_addchild
                       XCapa_frmPal_trcCapas
                       res_refx
                       capa
                     ) ;_ fin de dcl_tree_addchild
      ) ;_ fin de setq
      (dcl_Tree_SetItemImages
        XCapa_frmPal_trcCapas
        res_capa
        6
        7
      ) ;_ fin de dcl_Tree_SetItemImages
      (dcl_tree_expanditem XCapa_frmPal_trcCapas res_raiz 1)
      (dcl_tree_selectitem XCapa_frmPal_trcCapas res_raiz)
    ) ;_ fin de foreach
  ) ;_ fin de foreach
) ;_ fin de defun
;;;Listado 27.6. Funcin que crea los nodos del rbol.

(defun pinta-botones (sel-capa / activa lst-activa)
  (foreach capa (lis-capa)
    (if (wcmatch capa sel-capa)
      (progn (setq activa
                    (cdr
                      (assoc 62 (tblsearch "LAYER" capa))
                    ) ;_ fin de cdr
             ) ;_ fin de setq
             (if (minusp activa)
               (setq lst-activa (cons nil lst-activa))
               (setq lst-activa (cons t lst-activa))
             ) ;_ fin de if
      ) ;_ fin de progn
    ) ;_ fin de if
  ) ;_ fin de foreach
  (btn-act (comprueba-estado lst-activa))
) ;_ fin de defun
;;;Listado 27.7. Funcin auxiliar PINTA-BOTONES.

(defun comprueba-estado (lista / resultado)
  (cond ((apply 'and lista) (setq resultado 1))
        ((apply 'or lista) (setq resultado 0))
        (t (setq resultado -1))
  ) ;_ fin de cond
  resultado
) ;_ fin de defun
;;;Listado 27.8. Funcin COMPRUEBA-ESTADO.

(defun btn-act (estado)
  (cond ((= estado 1)
         (dcl_Control_SetPicture XCapa_frmPal_btnACT 100)
         (dcl_Control_SetMouseOverPicture
           XCapa_frmPal_btnACT
           107
         ) ;_ fin de dcl_Control_SetMouseOverPicture
        )
        ((= estado 0)
         (dcl_Control_SetPicture XCapa_frmPal_btnACT 101)
         (dcl_Control_SetMouseOverPicture
           XCapa_frmPal_btnACT
           108
         ) ;_ fin de dcl_Control_SetMouseOverPicture
        )
        (t
         (dcl_Control_SetPicture XCapa_frmPal_btnACT 102)
         (dcl_Control_SetMouseOverPicture
           XCapa_frmPal_btnACT
           109
         ) ;_ fin de dcl_Control_SetMouseOverPicture
        )
  ) ;_ fin de cond
) ;_ fin de defun
;;;Listado 27.9. Funcin que cambia la imagen del botn btnACT.

(defun inicia-vista (/ arbol)
  (setq arbol (dib-capa (lis-dib) (lis-capa)))
  (crea-nodos arbol)
  (setq *capa* "*")
  (pinta-botones *capa*)
) ;_ fin de defun
;;;Listado 27.10. Funcin que llena la vista en rbol.

(defun c:XCapa_frmPal_OnInitialize (/) (inicia-vista))
;;;Listado 27.11. Cdigo definitivo para el evento Initialize del formulario.
;;;c:XCapa_frmPal_TreeControl1_OnSelChanged
(defun c:XCapa_frmPal_trcCapas_OnSelChanged (Label Key / s-list)
  (setq s-list (cons Label s-list))
  (while (setq Key (dcl_Tree_GetParentItem
                     XCapa_frmPal_trcCapas
                     Key
                   ) ;_ fin de dcl_Tree_GetParentItem
         ) ;_ fin de setq
    (setq s-list (cons (dcl_Tree_GetItemLabel
                         XCapa_frmPal_trcCapas
                         Key
                       ) ;_ fin de dcl_Tree_GetItemLabel
                       s-list
                 ) ;_ fin de cons
    ) ;_ fin de setq
  ) ;_ fin de while
  (cond ((= (length s-list) 1) (setq *capa* "*"))
        ((and (= (length s-list) 2)
              (= (nth 1 s-list) (getvar "DWGNAME"))
         ) ;_ fin de and
         (setq *capa* "~*|*")
        )
        ((= (length s-list) 2)
         (setq *capa* (strcat (nth 1 s-list) "|*"))
        )
        ((and (= (length s-list) 3)
              (= (nth 1 s-list) (getvar "DWGNAME"))
         ) ;_ fin de and
         (setq *capa* (nth 2 s-list))
        )
        (t
         (setq *capa*
                (strcat (nth 1 s-list) "|" (nth 2 s-list))
         ) ;_ fin de setq
        )
  ) ;_ fin de cond
  (pinta-botones *capa*)
) ;_ fin de defun
;;;Listado 27.12. Respuesta al evento SelChanged del TreeControl.

(defun c:XCapa_frmPal_OnDocActivated (/)
  (dcl_Tree_Clear XCapa_frmPal_trcCapas)
  (inicia-vista)
) ;_ fin de defun
;;;Listado 27.13. Funcin de respuesta al evento DocActivated.

(defun c:XCapa_frmPal_OnEnteringNoDocState (/)
  (dcl_Form_CloseAll 64)
) ;_ fin de defun
;;;Listado 27.14. Cdigo para el evento EnteringNoDocState.

(defun c:XCapa_frmPal_btnACT_OnClicked (/)
  (vla-startundomark *aesl:dibujo*)
  (if (= (dcl_Control_GetPicture XCapa_frmPal_btnACT)
         100
      ) ;_ fin de =
    (progn (activa-capa *capa* (lis-capa) :vlax-false)
           (dcl_Control_SetPicture XCapa_frmPal_btnACT 102)
           (dcl_Control_SetMouseOverPicture
             XCapa_frmPal_btnACT
             109
           ) ;_ fin de dcl_Control_SetMouseOverPicture
    ) ;_ fin de progn
    (progn (activa-capa *capa* (lis-capa) :vlax-true)
           (dcl_Control_SetPicture XCapa_frmPal_btnACT 100)
           (dcl_Control_SetMouseOverPicture
             XCapa_frmPal_btnACT
             107
           ) ;_ fin de dcl_Control_SetMouseOverPicture
    ) ;_ fin de progn
  ) ;_ fin de if
  (vla-update *aesl:acad*)
  (vla-endundomark *aesl:dibujo*)
) ;_ fin de defun
;;;Listado 27.15. Respuesta al evento Clicked del btnACT.

(defun activa-capa (patron lista estado / col-capas)
  (setq col-capas (vla-get-layers *aesl:dibujo*))
  (foreach capa lista
    (if (wcmatch capa patron)
      (vla-put-layeron
        (vla-item col-capas capa)
        estado
      ) ;_ fin de vla-put-layeron
    ) ;_ fin de if
  ) ;_ fin de foreach
) ;_ fin de defun
;;;Listado 27.16. Funcin que activa o desactiva capas.

(defun c:XCapa_frmPal_btnCOLOR_OnClicked (/)
  (vla-startundomark *aesl:dibujo*)
  (if (setq s-col (acad_colordlg 256 t))
    (progn (setq col-capas (vla-get-layers *aesl:dibujo*))
           (vlax-for capa col-capas
             (if (wcmatch (vla-get-name capa) *capa*)
               (progn (vla-put-color capa s-col))
             ) ;_ fin de if
           ) ;_ fin de vlax-for
    ) ;_ fin de progn
    (vla-update *aesl:acad*)
  ) ;_ fin de if
  (vla-endundomark *aesl:dibujo*)
) ;_ fin de defun
;;;Listado 27.17. Funcin de respuesta para el evento Clicked de botn btnCOLOR.

(defun c:XCapa_frmPal_btnAISLA_OnClicked (/)
  (vla-startundomark *aesl:dibujo*)
  (setq col-capas (vla-get-layers *aesl:dibujo*))
  (foreach capa (lis-capa)
    (if (wcmatch capa *capa*)
      (vla-put-layeron (vla-item col-capas capa) :vlax-true)
      (vla-put-layeron (vla-item col-capas capa) :vlax-false)
    ) ;_ fin de if
  ) ;_ fin de foreach
  (pinta-botones *capa*)
  (vla-update *aesl:acad*)
  (vla-endundomark *aesl:dibujo*)
) ;_ fin de defun
;;;Listado 27.18. Funcin de respuesta al evento Clicked del control btnAISLA.

(defun c:XCapa_frmPal_btnDESH_OnClicked (/)
  (setvar "cmdecho" 0)
  (vla-sendcommand *aesl:dibujo* "._u \n")
  (setvar "cmdecho" 1)
  (pinta-botones "*")
) ;_ fin de defun
;;;Listado 27.19. Funcin de respuesta al evento Clicked del botn btnDESH.

(defun c:XCapa_frmPal_btnRENOV_OnClicked (/)
  (dcl_Tree_Clear XCapa_Trv_Capas)
  (inicia-vista)
) ;_ fin de defun
;;;Listado 27.20. Funcin de respuesta al evento Clicked del botn btnRENOV.


;|Visual LISP Format Options
(67 2 40 2 T "fin de " 55 9 0 0 1 nil T nil T)
;*** NO aadir texto a continuacin del comentario! ***|;
